Index: /mods/wpsg_mod_downloadplus.class.php
===================================================================
--- /mods/wpsg_mod_downloadplus.class.php	(revision 7823)
+++ /mods/wpsg_mod_downloadplus.class.php	(revision 7824)
@@ -1104,58 +1236,75 @@
 			");
 
-        $arLog = array();
-
-        foreach ($arPDFsUnindiv as $v)
-        {
-
-            $order_path = $this->getPDFIndivPath($v['o_id']);
-
-            $arBasket = $this->shop->cache->loadBasketArray($v['o_id']);
-
-            // Die Datei suchen, da ich das Produkt nicht mitspeichere
-            foreach ($arBasket['produkte'] as $p)
-            {
-
-                if ($p['id'] != $v['p_key']) continue;
-
-                $product_key = $p['id'];
-
-                $p['id'] = $this->shop->getProduktID($p['id']);
-
-                if ($this->isPDFProdukt($p['id']) && in_array($v['file'], $this->getFiles($p['id'])))
-                {
-
-                    $this->indivPDF(
-                        $product_key,
-                        $this->getPDFPath($p['id']).'/'.$v['file'],
-                        $this->getPDFIndivPath($v['o_id']).'/'.$v['out_file'],
-                        $v['o_id'],
-                        $v['downloadnr'],
-                        $v['id'],
-                        $v['product_index']
-                    );
-
-                    $this->db->UpdateQuery(WPSG_TBL_PDFINDIV, array(
-                        "done" => "NOW()"
-                    ), "`id` = '".wpsg_q($v['id'])."'");
-
-                    if (isset($arLog[$v['o_id']])) $arLog[$v['o_id']] ++;
-                    else $arLog[$v['o_id']] = 1;
-
-                    break;
-
-                }
-
-            }
-
-        }
-
-        $arClean = array();
-
-        // Alte Downloads sÃ€ubern
-        if ($this->shop->get_option('wpsg_mod_downloadplus_accepted') == '1' && $this->shop->get_option('wpsg_mod_downloadplus_cleanraiddownloads') == '1')
-        {
-
-            $arClean = array_merge($arClean, $this->db->fetchAssoc("
+	        $arLog = array();
+
+	        foreach ($arPDFsUnindiv as $v) {
+
+	            $order_path = $this->getPDFIndivPath($v['o_id']);
+
+	            $product_id = $this->shop->getProduktID($v['p_key']);
+
+	            if ($v['mode'] === '1') $src_path = $this->getPDFTemplatePath($v['template']);
+	            else $src_path = $this->getPDFPath($product_id);
+
+	            $oOrder = wpsg_order::getInstance(intval($v['o_id']));
+
+	            foreach ($oOrder->getOrderProducts() as $oOrderProduct) {
+
+	                if ($oOrderProduct->getProductKey() === $v['p_key']) {
+
+	                	$arFiles = $this->getFiles($oOrderProduct->getProductKey());
+
+	                	foreach ($arFiles as $f) {
+
+	                		if (file_exists($src_path.$f)) {
+
+	                			 $this->indivPDF(
+			                        $oOrderProduct->getProductKey(),
+			                        $src_path.$f,
+			                        $this->getPDFIndivPath($v['o_id']).'/'.$v['out_file'],
+			                        $v['o_id'],
+			                        $v['downloadnr'],
+			                        $v['id'],
+			                        $v['product_index']
+			                    );
+
+			                    if ($this->shop->get_option('wpsg_mod_downloadplus_emptypdf') === '1') {
+
+			                        $this->indivPDF(
+				                        $oOrderProduct->getProductKey(),
+			                            $src_path.$f,
+				                        $this->getPDFIndivPath($v['o_id']).'/clear_'.$v['out_file'],
+				                        $v['o_id'],
+				                        $v['downloadnr'],
+				                        $v['id'],
+				                        $v['product_index'],
+					                    false
+				                    );
+
+			                    }
+
+			                    $this->db->UpdateQuery(WPSG_TBL_PDFINDIV, array(
+			                        "done" => "NOW()"
+			                    ), "`id` = '".wpsg_q($v['id'])."'");
+
+			                    if (isset($arLog[$v['o_id']])) $arLog[$v['o_id']] ++;
+			                    else $arLog[$v['o_id']] = 1;
+
+			                }
+
+		                }
+
+	                }
+
+	            }
+
+	        }
+
+	        $arClean = array();
+
+	        // Alte Downloads sÃ€ubern
+	        if ($this->shop->get_option('wpsg_mod_downloadplus_accepted') == '1' && $this->shop->get_option('wpsg_mod_downloadplus_cleanraiddownloads') == '1') {
+
+	            $arClean = array_merge($arClean, $this->db->fetchAssoc("
 					SELECT
 						*
@@ -1166,9 +1315,7 @@
 				"));
 
-        }
-        else if ($this->shop->get_option('wpsg_mod_downloadplus_accepted') == '2' && $this->shop->get_option('wpsg_mod_downloadplus_cleanraiddownloads') == '1')
-        {
-
-            $arClean = array_merge($arClean, $this->db->fetchAssoc("
+	        } else if ($this->shop->get_option('wpsg_mod_downloadplus_accepted') == '2' && $this->shop->get_option('wpsg_mod_downloadplus_cleanraiddownloads') == '1') {
+
+	            $arClean = array_merge($arClean, $this->db->fetchAssoc("
 					SELECT
 						*
@@ -1179,10 +1326,157 @@
 				"));
 
-        }
-
-        if (intval($this->shop->get_option('wpsg_mod_downloadplus_cleanolddownloads')) > 0)
-        {
-
-            $arClean = array_merge($arClean, $this->db->fetchAssoc("
+	        }
+
+	        if (intval($this->shop->get_option('wpsg_mod_downloadplus_cleanolddownloads')) > 0) {
+
+	            $arClean = array_merge($arClean, $this->db->fetchAssoc("
+						SELECT
+							*
+						FROM
+							`".WPSG_TBL_PDFINDIV."`
+						WHERE
+							DATE_ADD(`done`, INTERVAL ".$this->shop->get_option('wpsg_mod_downloadplus_cleanolddownloads')." DAY) < NOW()
+					"));
+
+	        }
+
+	        if (wpsg_isSizedArray($arClean)) {
+
+	            foreach ($arClean as $c) {
+
+	                $path = $this->getPDFIndivPath($c['o_id']);
+
+	                unlink($path.'/'.$c['out_file']);
+
+	                $this->db->Query("DELETE FROM `".WPSG_TBL_PDFINDIV."` WHERE `id` = '".wpsg_q($c['id'])."'");
+
+	            }
+
+	        }
+
+	        if (wpsg_isSizedArray($arLog)) {
+
+	            $this->shop->view['arOrder'] = $arLog;
+
+	            foreach ($this->shop->view['arOrder'] as $k => $v) {
+
+	                $order = $this->shop->cache->loadOrder($k);
+
+	                $this->shop->view['arOrder'][$k] = array($v, $order, md5($order['cdate'].'wpsg'.$order['id']));
+
+	                if ($this->shop->get_option('wpsg_mod_downloadplus_autosend') == '1') {
+
+	                    $this->sendFiles($order['id']);
+
+	                }
+
+	            }
+
+	            $mail_text = $this->shop->render(WPSG_PATH_VIEW.'/mods/mod_downloadplus/cronmail.phtml', false);
+
+	            if ($this->shop->get_option('wpsg_htmlmail') === '1') {
+
+	                $mail_html = $this->shop->render(WPSG_PATH_VIEW.'/mods/mod_downloadplus/cronmail_html.phtml', false);
+
+	            } else {
+
+	                $mail_html = false;
+
+	            }
+
+	            $this->shop->sendMail($mail_text, $this->shop->get_option('wpsg_pdfdownloadcronmail_empfaenger'), 'pdfdownloadcronmail', array(), false, false, $mail_html);
+
+	        }
+
+	    } // public function cron()
+
+	    public function wpsg_mod_export_loadFields(&$arFields)
+	    {
+
+	        $arDPFields = array(
+	            'name' => __('Downloadplus', 'wpsg'),
+	            'fields' => array()
+	        );
+
+	        for ($i = 1; $i <= 10; $i ++)
+	        {
+
+	            $arDPFields['fields']['text'.$i] = wpsg_translate(__('Text in Textfeld #1#', 'wpsg'), $i);
+
+	        }
+
+	        $arDPFields['fields']['dnr'] = __('Downloadnummer', 'wpsg');
+
+	        $arFields[] = $arDPFields;
+
+	    } // public function wpsg_mod_export_loadFields(&$arFields)
+
+	    public function wpsg_mod_export_getValue(&$return, $field_value, $o_id, $p_id, $productkey, $product_index, $profil_separator)
+	    {
+
+	        // Individualisierung heraussuchen
+	        $db_indiv = $this->db->fetchRow("SELECT * FROM `".WPSG_TBL_PDFINDIV."` WHERE `o_id` = '".wpsg_q($o_id)."' AND `p_key` = '".wpsg_q($p_id)."' AND `product_index` = '".wpsg_q($product_index)."' ORDER BY `id` DESC LIMIT 1 ");
+
+	        switch ($field_value)
+	        {
+
+	            case 'dnr':
+	                if (!wpsg_isSizedInt($db_indiv['id'])) $return = ''; else $return = $db_indiv['downloadnr'];
+	                break;
+
+	            default:
+
+	                if (preg_match('/^text\d+$/', $field_value))
+	                {
+
+	                    $return = '';
+
+	                    if (wpsg_isSizedInt($db_indiv['id']))
+	                    {
+
+	                        $arTexte = unserialize($db_indiv['fielddata']);
+
+	                        if (wpsg_isSizedArray($arTexte))
+	                        {
+
+	                            $txt_nr = substr($field_value, 4);
+
+	                            $return = $arTexte['texte'][$txt_nr - 1];
+
+	                        }
+
+	                    }
+
+	                }
+
+	        } // switch
+
+	    } // public function wpsg_mod_export_getValue(&$return, $field_value, $o_id, $p_id, $product_index, $profil_separator)
+
+	    /**
+	     * Baut den Kontroll Hash
+	     */
+	    private function makeHash($indiv_id)
+	    {
+
+	        $indiv_db = $this->db->fetchRow("SELECT * FROM `".WPSG_TBL_PDFINDIV."` WHERE `id` = '".wpsg_q($indiv_id)."'");
+	        if ($indiv_db['id'] <= 0) return false;
+
+	        $order = $this->shop->cache->loadOrder($indiv_db['o_id']);
+	        if ($order['id'] <= 0) return false;
+
+	        $strHash = md5($order['cdate'].'wpsg'.$indiv_db['file']);
+
+	        return $strHash;
+
+	    } // private function makeHash($indiv_id)
+
+	    /**
+	     * Sendet die Mail mit den Downloadlinks an den Kunden
+	     */
+	    public function sendFiles($order_id)
+	    {
+
+	        $this->shop->view['arPDFs'] = $this->db->fetchAssoc("
 					SELECT
 						*
